//The bee path finder attempts to find a path around obstacles by flying a box pattern around them.

require("AntPathFinder.nut");

class BeePathFinder
{
  start = null;
  goal = null;
  current = null;
  path = null;
  count = null;
  x1 = null;
  x2 = null;
  y1 = null;
  y2 = null;

  constructor(start, goal)
  {
    this.start = start;
    this.current = start;
    this.goal = goal;
    this.count = 1;
    this.path = AIList();
    this.path.AddItem(start, count);
    x1 = AIMap.GetTileX(start);
    y1 = AIMap.GetTileY(start);
  
    x2 = AIMap.GetTileX(goal);  
    y2 = AIMap.GetTileY(goal);
  }

}

function BeePathFinder::FindPath()
{
  return false;
  local foundPath = false;
  
  if(x1 < x2 && y1 < y2) // Start NorthWest
  {
    foundPath = this.CheckNWtoSE();
  }
  
  if(x1 > x2 && y1 < y2)// Start SouthWest
  {
    foundPath = this.CheckSWtoNE();
  }
  
  if(x1 < x2 && y1 > y2)// start NorthEast
  {
    foundPath = this.CheckNEtoSW();
  }
  
  if(x1 > x2 && y1 > y2)// start SouthEast
  {
    foundPath = this.CheckSEtoNW();
  }

  if(foundPath)
  {
    foreach(tile, v in path)
    {
      AISign.BuildSign(tile, "B");
    }
    return true;
  }
  
  this.path = null;
  return false;
}

function BeePathFinder::CheckPath(tiles)
{
  if(tiles.Count() == 0) { throw "Unexpected empty list."};
  
  local startCount = tiles.Count();
  local checkList = AIList();
  checkList.AddList(tiles);

  checkList.Valuate(AntPathFinder.isBuildable);
  checkList.KeepValue(1);
  
  if(startCount == checkList.Count())
  {
    print ("Bee prevails. " + startCount);
    return true;
  }
}

function BeePathFinder::CheckNWtoSE()
{
  local tile = start;
  
  local tiles = this.GetESLeg(tile);
  if(this.CheckPath(tiles))
  {
    this.path.AddList(tiles);
    return true;
  }
  
  count = 0;
  tiles = this.GetSELeg(tile);
  if(this.CheckPath(tiles))
  {
    //this.path.AddList(tiles);
    this.path = tiles;
    return true;
  }
  
  return false;
}

function BeePathFinder::CheckNEtoSW()
{
  local tile = start;
  
  local tiles = this.GetWSLeg(tile);
  if(this.CheckPath(tiles))
  {
    this.path.AddList(tiles);
    
    path.Sort(AIAbstractList.SORT_BY_VALUE, true);
    return true;
  }
  
  count = 0;
  tiles = this.GetSWLeg(tile);
  if(this.CheckPath(tiles))
  {
    this.path.AddList(tiles);
    
    path.Sort(AIAbstractList.SORT_BY_VALUE, true);
    return true;
  }
  
  return false;
}


function BeePathFinder::CheckSEtoNW()
{
  local tile = start;
  
  local tiles = this.GetWNLeg(tile);
  if(this.CheckPath(tiles))
  {
    this.path.AddList(tiles);
    
    path.Sort(AIAbstractList.SORT_BY_VALUE, true);
    return true;
  }
  
  count = 0;
  tiles = this.GetNWLeg(tile);
  if(this.CheckPath(tiles))
  {
    this.path.AddList(tiles);
    
    path.Sort(AIAbstractList.SORT_BY_VALUE, true);
    return true;
  }
  
  return false;
}

function BeePathFinder::CheckSWtoNE()
{
  local tile = start;
  
  local tiles = this.GetENLeg(tile);
  if(this.CheckPath(tiles))
  {
    this.path.AddList(tiles);
    
    path.Sort(AIAbstractList.SORT_BY_VALUE, true);
    return true;
  }
  
  count = 0;
  tiles = this.GetNELeg(tile);
  if(this.CheckPath(tiles))
  {
    this.path.AddList(tiles);
    
    path.Sort(AIAbstractList.SORT_BY_VALUE, true);
    return true;
  }
  
  return false;
}



function BeePathFinder::GetESLeg(tile)
{
    local tiles = AIList();
    
    for(local i = 0; i < abs(y1 - y2); i ++)
    {
      tile = this.GetTileToEast(tile);
      tiles.AddItem(tile, count++);
    }
    
    for(local i = 0; i < abs(x1 - x2); i ++)
    {
      tile = this.GetTileToSouth(tile);
      tiles.AddItem(tile, count++);
    }
        
    return tiles;
}

function BeePathFinder::GetSELeg(tile)
{
    local tiles = AIList();
    
    for(local i = 0; i < abs(x1 - x2); i ++)
    {
      tile = this.GetTileToSouth(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    for(local i = 0; i < abs(y1 - y2); i ++)
    {
      tile = this.GetTileToEast(tile);
      tiles.AddItem(tile, count++);
    }
    
    tiles.Sort(AIAbstractList.SORT_BY_VALUE, true);
    return tiles;
}

function BeePathFinder::GetWSLeg(tile)
{
    local tiles = AIList();
    
    for(local i = 0; i < abs(y1 - y2); i ++)
    {
      tile = this.GetTileToWest(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    for(local i = 0; i < abs(x1 - x2); i ++)
    {
      tile = this.GetTileToSouth(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    return tiles;
}


function BeePathFinder::GetWNLeg(tile)
{
    local tiles = AIList();
    
    for(local i = 0; i < abs(y1 - y2); i ++)
    {
      tile = this.GetTileToWest(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    for(local i = 0; i < abs(x1 - x2); i ++)
    {
      tile = this.GetTileToNorth(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    
    return tiles;
}

function BeePathFinder::GetNWLeg(tile)
{
    local tiles = AIList();
    
    for(local i = 0; i < abs(x1 - x2); i ++)
    {
      tile = this.GetTileToNorth(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    for(local i = 0; i < abs(y1 - y2); i ++)
    {
      tile = this.GetTileToWest(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    return tiles;
}

function BeePathFinder::GetNELeg(tile)
{
    local tiles = AIList();
    
    for(local i = 0; i < abs(x1 - x2); i ++)
    {
      tile = this.GetTileToNorth(tile);
      tiles.AddItem(tile, count++);
      //AISign.BuildSign(tile, ""+ count);
    }
    
    
    for(local i = 0; i < abs(y1 - y2); i ++)
    {
      tile = this.GetTileToEast(tile);
      tiles.AddItem(tile, count++);
      //AISign.BuildSign(tile, ""+ count);
    }
    
    
    return tiles;
}


function BeePathFinder::GetSWLeg(tile)
{
    local tiles = AIList();
    
    for(local i = 0; i < abs(x1 - x2); i ++)
    {
      tile = this.GetTileToSouth(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    for(local i = 0; i < abs(y1 - y2); i ++)
    {
      tile = this.GetTileToWest(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    return tiles;
}

function BeePathFinder::GetENLeg(tile)
{
    local tiles = AIList();
    
    for(local i = 0; i < abs(y1 - y2); i ++)
    {
      tile = this.GetTileToEast(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    for(local i = 0; i < abs(x1 - x2); i ++)
    {
      tile = this.GetTileToNorth(tile);
      tiles.AddItem(tile, count++);
    }
    
    
    return tiles;
}


function BeePathFinder::GetTileToNorth(tile)
{
  if(tile == goal) {return;}
  local x = AIMap.GetTileX(tile);
  local y = AIMap.GetTileY(tile);
  
  x--;
  
  return AIMap.GetTileIndex(x,y);
}

function BeePathFinder::GetTileToSouth(tile)
{
  if(tile == goal) {return;}
  local x = AIMap.GetTileX(tile);
  local y = AIMap.GetTileY(tile);
  
  x++;
  
  
  return AIMap.GetTileIndex(x,y);
}

function BeePathFinder::GetTileToWest(tile)
{
  if(tile == goal) {return;}
  local x = AIMap.GetTileX(tile);
  local y = AIMap.GetTileY(tile);
  
  y--;
  
  
  return AIMap.GetTileIndex(x,y);
}

function BeePathFinder::GetTileToEast(tile)
{
  if(tile == goal) {return;}
  local x = AIMap.GetTileX(tile);
  local y = AIMap.GetTileY(tile);
  
  y++;
  
  return AIMap.GetTileIndex(x,y);
}