class BridgePathFinder
{
  start = null;
  goal = null;
  current = null;
  path = null;
  count = null;
  
  display_thinking = null;
  bridge_max_len = null;
  

  constructor(start, goal)
  {
    this.start = start;
    this.current = start;
    this.goal = goal;
    this.count = 0;
    this.path = AIList();
    this.display_thinking = AIController.GetSetting("display_thinking");
    this.bridge_max_len = AIController.GetSetting("bridge_max_len");
  }

}

function BridgePathFinder::FindPath()
{
  if(display_thinking) { AISign.BuildSign(this.current, "{B}"); }
  local test = AITestMode();
  
  local dist = AIMap.DistanceManhattan(this.current, goal);
  if(dist > this.bridge_max_len) {return false;}
  
  local firstTile = GetNextClosestTileAny(start, goal);
  local lastTile = GetNextClosestTileAny(goal, start);
  
  if(dist > 6)
  {
   
   local bridge_list = AIBridgeList_Length(AIMap.DistanceManhattan(start, goal) + 1);
   if(bridge_list.Count() == 0) {return false;}
   bridge_list.Valuate(AIBridge.GetMaxSpeed);
   bridge_list.Sort(AIAbstractList.SORT_BY_VALUE, false);
   local bridgeBuildable = AIBridge.BuildBridge(AIVehicle.VT_RAIL, bridge_list.Begin(), firstTile, lastTile);
    if(bridgeBuildable)
    {
      AISign.BuildSign(start, "B1");
      AISign.BuildSign(firstTile, "B2");
      AISign.BuildSign(lastTile, "B3");
      AISign.BuildSign(goal, "B4");
    
      this.path.AddItem(start, count++);
      this.path.AddItem(firstTile, count++);
      this.path.AddItem(lastTile, count++);
      this.path.AddItem(goal, count++);
      return true;
    }
  }
  
  return false;
}

function BridgePathFinder::GetNextClosestTileAny(tile, goal)
{
  local nodelist = AntHill.FindCompassPointsNunitsAway(tile, 1);
  nodelist.Valuate(DistanceValuator, goal);
  nodelist.Sort(AIAbstractList.SORT_BY_VALUE, true);
  foreach(i, v in nodelist)
  {
    AISign.BuildSign(i, ""+v);
  }
  
  
  local node = nodelist.Begin();
  AISign.BuildSign(node, "N");
  return node;
}

function BridgePathFinder::DistanceValuator(tile, goal)
{
 return AITile.GetDistanceSquareToTile(tile, goal);
}