class TownManager
{  
  Index = null;
  Location = null;
  Name = null;
  
  startRadius = 5;
  constructor(townIndex)
  {
    this.Index = townIndex;
    Location = AITown.GetLocation(townIndex);
    Name = AITown.GetName(townIndex);
  }
}


function TownManager::GetBoundingRect()
{
  local rectangle = AIList();
  local tiles = AITileList();
  
  local radius = 5;
  local hasjunk = true;
  local tile1 = null;
  local tile2 = null;
  
  
  tile1 = Location + AIMap.GetTileIndex(-radius, -radius);
  tile2 = Location + AIMap.GetTileIndex(radius, radius);
  
  tiles.AddRectangle(tile1, tile2);
  return tiles;
 
}

function TownManager::GetCirclingRect()
{
  local rectangle = AIList();
  local tiles = AITileList();
  
  local radius = 5;
  local hasjunk = true;
  while(radius < 20 && hasjunk == true)
  {
    local tile1 = Location + AIMap.GetTileIndex(-radius, -radius);
    local tile2 = Location + AIMap.GetTileIndex(radius, radius);
    local tile3 = Location + AIMap.GetTileIndex(-radius + 1, -radius + 1);
    local tile4 = Location + AIMap.GetTileIndex(radius - 1, radius - 1);
  
    tiles.AddRectangle(tile1, tile2);
    tiles.RemoveRectangle(tile3, tile4);
    
    hasjunk = false;
    foreach(tile, v in tiles)
    {
      //AISign.BuildSign(tile, "'");
      if(!(AITile.IsBuildable(tile) || AITile.IsWaterTile(tile) || AIRoad.IsRoadTile(tile) )) {hasjunk = true;}
    }
    radius++;
  }
  

  if(hasjunk == false)
  {
    
    rectangle.AddList(tiles);
    rectangle.Valuate(AITile.GetDistanceManhattanToTile, rectangle.Begin());
    rectangle.Sort(AIAbstractList.SORT_BY_VALUE, true)
    return rectangle;
  }
  return null;
}


function TownManager::BoxInTown()
{
    local rectangle = this.GetCirclingRect();
    local odds = AIList();
    local evens = AIList();
  
    local count = 0;
    foreach(tile, v in rectangle)
    {
      count++;
      if(count % 2 == 0)
      {
        evens.AddItem(tile, count);
      }
      else
      {
        odds.AddItem(tile, count);
      }
    }
    
    BuildRoads(evens);
    BuildRoads(odds);

}

function TownManager::BuildRoads(list)
{
  list.Sort(AIAbstractList.SORT_BY_VALUE, true);
  
  list.Valuate(AITile.IsBuildable);
  list.KeepValue(1);
  local current = list.Begin();
  local next = null;
  while(next = list.Next())
  {
    AIRoad.BuildRoad(current, next);
    current = next;
  }

}
